From 87d52247685cb6a7139692b136ab7833110f5804 Mon Sep 17 00:00:00 2001
From: Ambriel Skoeld <ambriel.archangel@icloud.com>
Date: Thu, 2 Apr 2020 17:22:26 +0200
Subject: [PATCH] :heart::heart::heart:.wav

---
 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/Home.md                 |  24 ++++++++++++++++++++++++
 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/artifact.rb             |  31 +++++++++++++++++++++++++++++++
 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/get-version.py          |   0
 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/move-check.sh           |  90 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/set-vertical-metrics.py | 113 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 258 insertions(+)
 create mode 100644 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/Home.md
 create mode 100644 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/artifact.rb
 create mode 100644 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/get-version.py
 create mode 100755 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/move-check.sh
 create mode 100644 httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/set-vertical-metrics.py

diff --git a/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/Home.md b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/Home.md
new file mode 100644
index 0000000..4e7a427
--- /dev/null
+++ b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/Home.md
@@ -0,0 +1,24 @@
+
+Azure App Service is the Platform as a Service (PaaS) offering from Azure that let's you deploy, manage, and scale your applications with ease. 
+
+## How App Service works
+
+There are two unique pieces of Azure that make App Service work differently from other PaaS providers. The first is **Resource Groups**, which are logical groupings of Azure resources. The second is the **App Service Plan**, which define the infrastructure where you application instances are deployed.
+
+### App Service Plans
+
+An App Service Plan provides a way for you to define the region and pricing tier (VM capacity and features) that can be shared across web apps deployed from the App Service extension. Simply put, the Plan defines the Virtual Machine that will host the web apps that you deploy from the extension.
+
+An Azure web app may exist in a single App Service Plan at any given time. Or when needed, a web app may be moved to another App Service Plan. This gives you the flexibility of starting your web app development in an App Service Plan configured for the Free tier and then upgrading to an App Service Plan configured for a higher pricing tier as your application and development requirements expand.
+
+> **TIP:** An App Service Plan can be used for multiple Web Apps.
+
+At any time, you can change the pricing tier for your App Service Plan. So it is not necessary to create a new one if you need to move to a higher or lower pricing tier.
+
+### Resource Groups
+
+An Azure Resource Group is a logical container for grouping Azure resources. For example, a website may have a web API, front end with UI, and a database in which to store data. The web front end, API and database are individual resources that comprise the full web solution. An Azure Resource Group gives you a natural way to manage and monitor resources that comprise a solution.
+
+Below is an example of what an Azure Resource Group could look like for a web app consisting of an Azure web app (with three app instances), Cosmos DB database, and an Azure Storage account for serving front end UI code. Notice that the App Service extension only manages the App Service Plan and App Instances deployed to the plan.
+
+![App Service Anatomy](https://user-images.githubusercontent.com/1186948/51127485-66695800-17da-11e9-8201-9756596521fe.png)
\ No newline at end of file
diff --git a/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/artifact.rb b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/artifact.rb
new file mode 100644
index 0000000..07d8925
--- /dev/null
+++ b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/artifact.rb
@@ -0,0 +1,31 @@
+# frozen_string_literal: true
+
+require "cask/artifact/app"
+require "cask/artifact/artifact" # generic 'artifact' stanza
+require "cask/artifact/audio_unit_plugin"
+require "cask/artifact/binary"
+require "cask/artifact/colorpicker"
+require "cask/artifact/dictionary"
+require "cask/artifact/font"
+require "cask/artifact/input_method"
+require "cask/artifact/installer"
+require "cask/artifact/internet_plugin"
+require "cask/artifact/manpage"
+require "cask/artifact/vst_plugin"
+require "cask/artifact/vst3_plugin"
+require "cask/artifact/pkg"
+require "cask/artifact/postflight_block"
+require "cask/artifact/preflight_block"
+require "cask/artifact/prefpane"
+require "cask/artifact/qlplugin"
+require "cask/artifact/screen_saver"
+require "cask/artifact/service"
+require "cask/artifact/stage_only"
+require "cask/artifact/suite"
+require "cask/artifact/uninstall"
+require "cask/artifact/zap"
+
+module Cask
+  module Artifact
+  end
+end
diff --git a/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/get-version.py b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/get-version.py
new file mode 100644
index 0000000..e69de29
--- /dev/null
+++ b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/get-version.py
diff --git a/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/move-check.sh b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/move-check.sh
new file mode 100755
index 0000000..01c3268
--- /dev/null
+++ b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/move-check.sh
@@ -0,0 +1,90 @@
+#!/bin/bash
+
+# This script copies the latest builds to the google fonts dir in order to run QA checks and prep for a PR
+#
+# USAGE: 
+# Install requirements with `pip install -U -r googlefonts-qa/requirements.txt`
+# 
+# call this script from the root of your fira code repo, with the absolute path your your local google/fonts repo
+# `move-check <your_username>/<path>/fonts`
+
+set -ex
+source venv/bin/activate
+gFontsDir=$1
+
+if [[ -z "$gFontsDir" || $gFontsDir = "--help" ]] ; then
+    echo 'Add absolute path to your Google Fonts Git directory, like:'
+    echo 'googlefonts-qa/scripts/move-check.sh /Users/your-username/type-repos/google-font-repos/fonts'
+    exit 2
+fi
+
+firaCodeDir=$(pwd)
+
+firaCodeQADir=$firaCodeDir/googlefonts-qa
+
+firaCodeVF=$firaCodeDir/distr/variable_ttf/FiraCode-VF.ttf
+
+
+# -------------------------------------------------------------------
+# get latest version ------------------------------------------------
+
+ttx -t head $firaCodeVF
+fontVersion=v$(xml sel -t --match "//*/fontRevision" -v "@value" ${firaCodeVF/".ttf"/".ttx"})
+rm ${firaCodeVF/".ttf"/".ttx"}
+
+# -------------------------------------------------------------------
+# navigate to google/fonts repo, then fira code branch --------------
+
+cd $gFontsDir
+git checkout master
+git pull upstream master
+git reset --hard
+git checkout -B firacode
+git clean -f -d
+
+# -------------------------------------------------------------------
+# move fonts --------------------------------------------------------
+
+mkdir -p ofl/firacode
+
+cp $firaCodeVF    "ofl/firacode/FiraCode-Light.ttf"
+
+mkdir -p ofl/firacode/static
+statics=$(ls $firaCodeDir/distr/ttf/*.ttf)
+for ttf in $statics
+do
+    cp $ttf ofl/firacode/static/$(basename $ttf)
+done
+
+# -------------------------------------------------------------------
+# make or move basic metadata ---------------------------------------
+
+cp $firaCodeDir/googlefonts-qa/METADATA.pb ofl/firacode/METADATA.pb
+
+cp $firaCodeDir/LICENSE ofl/firacode/OFL.txt
+
+cp $firaCodeQADir/gfonts-description.html ofl/firacode/DESCRIPTION.en_us.html
+
+# -------------------------------------------------------------------
+# run checks, saving to firacode/googlefonts-qa/checks ------------
+
+set +e # otherwise, the script stops after the first fontbakery check output
+
+mkdir -p $firaCodeQADir/checks/static
+
+cd ofl/firacode
+
+ttfs=$(ls -R */*.ttf && ls *.ttf) # use this to statics and VFs
+# ttfs=$(ls *.ttf) # use this to check only the VFs
+# ttfs=$(ls -R */*.ttf ) # use this to check only statics
+
+for ttf in $ttfs
+do
+    echo $ttf
+    fontbakery check-googlefonts $ttf --ghmarkdown $firaCodeQADir/checks/${ttf/".ttf"/".checks.md"}
+done
+
+git add .
+git commit -m "fira code: $fontVersion added."
+
+git push --force upstream firacode
\ No newline at end of file
diff --git a/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/set-vertical-metrics.py b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/set-vertical-metrics.py
new file mode 100644
index 0000000..f68e320
--- /dev/null
+++ b/httpsopen.spotify.comtrack2jwxVmUqXWsMpROLqujbsx.rtfd/set-vertical-metrics.py
@@ -0,0 +1,113 @@
+#MenuTitle: Set Vertical Metric Params
+# -*- coding: utf-8 -*-
+
+font = Glyphs.font
+
+print(font)
+
+__doc__="""
+  Assumes the masters keep the same vertical metrics. 
+  
+  I am not sure whether winAscent and winDescent should be different between masters, 
+  otherwise, but you should check if that's the case before using this script 
+  on a font where min/max heights are different between styles. 
+
+  Useful when created; may or may not match the latest Google Fonts vertical metrics standards. 
+"""
+
+font = Glyphs.font
+
+
+
+caps = ["A", "Aacute", "Abreve", "Acircumflex", "Adieresis", "Agrave", "Amacron", "Aogonek", "Aring", "Aringacute", "Atilde", "AE", "AEacute", "B", "C", "Cacute", "Ccaron", "Ccedilla", "Ccircumflex", "Cdotaccent", "D", "Eth", "Dcaron", "Dcroat", "Ddotbelow", "E", "Eacute", "Ebreve", "Ecaron", "Ecircumflex", "Edieresis", "Edotaccent", "Edotbelow", "Egrave", "Emacron", "Eogonek", "Etilde", "F", "G", "Gbreve", "Gcircumflex", "Gcommaaccent", "Gdotaccent", "H", "Hbar", "Hcircumflex", "Hdotbelow", "I", "IJ", "Iacute", "Ibreve", "Icircumflex", "Idieresis", "Idotaccent", "Idotbelow", "Igrave", "Imacron", "Iogonek", "Itilde", "J", "Jcircumflex", "K", "Kcommaaccent", "L", "Lacute", "Lcaron", "Lcommaaccent", "Ldot", "Lslash", "M", "N", "Nacute", "Ncaron", "Ncommaaccent", "Ndotaccent", "Eng", "Ntilde", "O", "Oacute", "Obreve", "Ocircumflex", "Odieresis", "Odotbelow", "Ograve", "Ohungarumlaut", "Omacron", "Oogonek", "Oslash", "Oslashacute", "Otilde", "OE", "P", "Thorn", "Q", "R", "Racute", "Rcaron", "Rcommaaccent", "Rdotbelow", "S", "Sacute", "Scaron", "Scircumflex", "Sdotbelow", "Schwa", "T", "Tbar", "Tcaron", "Tdotbelow", "U", "Uacute", "Ubreve", "Ucircumflex", "Udieresis", "Udotbelow", "Ugrave", "Uhungarumlaut", "Umacron", "Uogonek", "Uring", "Utilde", "V", "W", "Wacute", "Wcircumflex", "Wdieresis", "Wgrave", "X", "Y", "Yacute", "Ycircumflex", "Ydieresis", "Ygrave", "Ytilde", "Z", "Zacute", "Zcaron", "Zdotaccent", "Zdotbelow", "uni015E", "uni0162", "uni01C4", "uni01C5", "uni01C7", "uni01C8", "uni01CA", "uni01CB", "uni01F1", "uni01F2", "uni0218", "uni021A" ]  
+lowercase = ["a", "aacute", "abreve", "acircumflex", "adieresis", "agrave", "amacron", "aogonek", "aring", "aringacute", "atilde", "ae", "aeacute", "b", "c", "cacute", "ccaron", "ccedilla", "ccircumflex", "cdotaccent", "d", "eth", "dcaron", "dcroat", "ddotbelow", "e", "eacute", "ebreve", "ecaron", "ecircumflex", "edieresis", "edotaccent", "edotbelow", "egrave", "emacron", "eogonek", "etilde", "schwa", "f", "g", "gbreve", "gcircumflex", "gcommaaccent", "gdotaccent", "h", "hbar", "hcircumflex", "hdotbelow", "i", "dotlessi", "iacute", "ibreve", "icircumflex", "idieresis", "idotbelow", "igrave", "ij", "imacron", "iogonek", "itilde", "j", "dotlessj", "jcircumflex", "k", "kcommaaccent", "kgreenlandic", "l", "lacute", "lcaron", "lcommaaccent", "ldot", "lslash", "m", "n", "nacute", "napostrophe", "ncaron", "ncommaaccent", "ndotaccent", "eng", "ntilde", "o", "oacute", "obreve", "ocircumflex", "odieresis", "odotbelow", "ograve", "ohungarumlaut", "omacron", "oogonek", "oslash", "oslashacute", "otilde", "oe", "p", "thorn", "q", "r", "racute", "rcaron", "rcommaaccent", "rdotbelow", "s", "sacute", "scaron", "scircumflex", "sdotbelow", "germandbls", "t", "tbar", "tcaron", "tdotbelow", "u", "uacute", "ubreve", "ucircumflex", "udieresis", "udotbelow", "ugrave", "uhungarumlaut", "umacron", "uni015F", "uni0163", "uni01C6", "uni01C9", "uni01CC", "uni01F3", "uni0219", "uni021B", "uogonek", "uring", "utilde", "v", "w", "wacute", "wcircumflex", "wdieresis", "wgrave", "x", "y", "yacute", "ycircumflex", "ydieresis", "ygrave", "ytilde", "z", "zacute", "zcaron", "zdotaccent", "zdotbelow", "c_t", "f_b", "f_f", "f_f_b", "f_f_h", "f_f_i", "f_f_j", "f_f_k", "f_f_l", "f_f_t", "f_h", "f_i", "f_j", "f_k", "f_l", "f_t", "s_t", ]
+
+# starter values
+mainMaxDescent = 0
+mainMaxDescentGlyph = ""
+maxDescent = 0
+mainMaxAscent = 0
+mainMaxAscentGlyph = ""
+maxAscent = 0
+
+# find highest and lowest point in font
+for glyph in font.glyphs:
+
+  # get total yMax and yMin, for win values
+  for layer in glyph.layers:
+  
+    # get descender of current layer
+    descent = layer.bounds.origin.y
+    
+    # get ascender of current layer
+    ascent = layer.bounds.size.height + descent  
+
+    # if descent/ascent of current layer is greater than previous max descents/ascents, update the max descent/ascent
+    if descent <= maxDescent:
+      maxDescent = descent
+      maxDescentGlyph = glyph.name
+      
+    if ascent >= maxAscent:
+      maxAscent = ascent
+      maxAscentGlyph = glyph.name
+
+  # get descender of current layer
+  descent = layer.bounds.origin.y
+      
+  # get ascender of current layer (total height of layer, subtracting value of descender)
+  ascent = layer.bounds.size.height + descent
+
+  # get maximums of only letters in list vars, for typo and hhea values
+  if glyph.name in caps:
+
+    for layer in glyph.layers:
+      if ascent >= mainMaxAscent:
+        mainMaxAscent = ascent
+        mainMaxAscentGlyph = glyph.name
+
+
+  if glyph.name in lowercase:
+      # if descent/ascent of current layer is greater than previous max descents/ascents, update the max descent/ascent
+      if descent <= mainMaxDescent:
+        mainMaxDescent = descent
+        mainMaxDescentGlyph = glyph.name
+
+
+      
+
+# check values for sanity
+print(maxDescentGlyph, maxDescent, maxAscentGlyph, maxAscent)
+
+# make lineGap so that the total of `ascent + descent + lineGap` equals 120% of UPM size
+
+UPM = font.upm
+
+totalSize = maxAscent + abs(maxDescent)
+
+# lineGap = int((UPM * 1.2)) - totalSize
+
+# print(UPM, UPM * 1.2, totalSize, lineGap)
+
+## use highest/lowest points to set custom parameters for winAscent and winDescent
+## following vertical metric schema from https://github.com/googlefonts/gf-docs/tree/master/VerticalMetrics (actually, that source must be updated to better recommendations found at https://github.com/googlefonts/fontbakery/issues/2164#issuecomment-436595886)
+
+font.customParameters["Use Typo Metrics"] = True
+
+for master in font.masters:
+
+  # Win Ascent/Descent = Font bbox yMax/yMin
+  master.customParameters["winAscent"] = maxAscent
+  master.customParameters["winDescent"] = abs(maxDescent)
+
+  typoLineGap = 0
+  master.customParameters["typoLineGap"] = typoLineGap
+  master.customParameters["hheaLineGap"] = typoLineGap
+
+  typoDescender = mainMaxDescent
+  master.customParameters["typoDescender"] = typoDescender
+  master.customParameters["hheaDescender"] = typoDescender
+
+  typoAscender = mainMaxAscent
+  master.customParameters["typoAscender"] = typoAscender
+  master.customParameters["hheaAscender"] = typoAscender
+
--
Working Copy 4.1.5

